<template>
  <div class="wallet-transactions" :class="{ 'is-active': showSection }">
    <div class="wallet-transactions__top" @click="showSection = !showSection">
      <div class="wallet-transactions__amount">
        + - {{ data.amount }} token
      </div>
      <div class="wallet-transactions__info">i</div>
    </div>
    <div v-if="showSection" class="wallet-transactions__row">
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Description</div>
        <div v-if="data.attachment" class="wallet-transactions__value">
          {{ onBase58(data.attachment) }}
        </div>
        <div class="wallet-transactions__value" v-else>–</div>
      </div>
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Block</div>
        <div v-if="data.height" class="wallet-transactions__value">
          {{ data.height }}
        </div>
        <div class="wallet-transactions__value" v-else>–</div>
      </div>
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Proofs</div>
        <div v-if="data.proofs" class="wallet-transactions__value">
          {{ data.proofs[0] }}
        </div>
        <div class="wallet-transactions__value" v-else>–</div>
      </div>
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Fee</div>
        <div class="wallet-transactions__value">
          {{ onCalc(data.fee, 8) }}
          {{ data.feeAsset ? data.feeAsset : 'Waves' }}
        </div>
      </div>
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Date</div>
        <div class="wallet-transactions__value">
          {{ format(new Date(data.timestamp), 'dd.MM.yyyy – hh:mm') }}
        </div>
      </div>
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Status</div>
        <div class="wallet-transactions__value status">
          {{ data.applicationStatus }}
        </div>
      </div>
      <div class="wallet-transactions__item">
        <div class="wallet-transactions__label">Blockchain data</div>
        <div class="wallet-transactions__value">
          <a
            :href="`https://wavesexplorer.com/tx/${data.id}`"
            target="_blank"
          >
            wavesexplorer.com
          </a>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import { format } from 'date-fns'
export default defineComponent<{
  data: Array<any>
  showSection: Boolean
}>({
  name: 'Transaction',
  props: ['data'],

  setup() {
    const showSection = false

    const onCalc = (amount: any, decimals: any) => {
      return amount / Math.pow(10, decimals)
    }
    const onBase58 = (str: any) => {
      const Base58 = require('base-58')
      const decode = new Buffer(Base58.decode(str))
      return decode.toString('utf8')
    }

    return {
      showSection,
      format,
      onCalc,
      onBase58
    }
  }
})
</script>

<style lang="scss" scoped>
.wallet {
  &-transactions {
    margin-bottom: 20px;
    background: #292e3c;
    border-radius: 10px;
    &__row {
      padding: 25px 30px 35px 30px;
      border-top: 2px solid #1f232f;
    }
    &__item {
      display: flex;
      align-items: center;
      justify-content: space-between;
      border-radius: 5px;
      padding: 12px 20px;
      &:nth-child(odd) {
        background: #2f3443;
      }
      > * {
        flex: 0 0 50%;
      }
    }
    &__top {
      padding: 20px 30px;
      user-select: none;
      cursor: pointer;
      display: flex;
      align-items: center;
      justify-content: space-between;
    }
    &__info {
      background: #1f232f;
      border-radius: 50%;
      width: 30px;
      height: 30px;
      display: flex;
      align-items: center;
      justify-content: center;
      font-family: 'Video Cond';
      font-size: 18px;
      line-height: 18px;
      letter-spacing: 0px;
      color: #ffffff;
    }
    &__amount {
      color: #ffffff;
      font-weight: bold;
      font-size: 30px;
      line-height: 37px;
    }
    &__label {
      color: #8591ad;
      font-size: 18px;
      line-height: 23px;
      font-weight: 500;
    }
    &__value {
      color: #ffffff;
      font-weight: 500;
      font-size: 18px;
      line-height: 23px;
      text-align: right;
      word-break: break-all;
      /* white-space: nowrap;
      text-overflow: ellipsis;
      overflow: hidden; */
      a {
        color: #0065ff;
      }
      &.status {
        color: #00ffb3;
      }
    }
  }
}
</style>
